
---------------------------------------------------------------------------------------------
-- Practica de Enginyeria del Software II / Curs 2003 - 2004                               --
-- Simulador i Controlador de Transit en Temps Real                                        --
--                                                                                         --
-- Accions.adb: Implementacio d'una instancia de Llista_Dinamica per tractar les diferents --
--              operacions de manegament de les possibles accions a dur a terme en la      --
--              interficie, indicades per totes les tasques del simulador i sent la tasca  --
--              actualitzadora de la interficie l'encarregada d'extreure les diferents     --
--              accions i de cridar al metode corresponent de ciutats.adb per a que        --
--              invoqui l'actualizacio de la interficie de forma que una sola tasca faci   --
--              l'actualitzacio. S'evita aixi el coll d'ampolla en l'acces a un recurs     --
--              en exclusio mutua (la interficie), requerit per totes les tasques.         --
-- Realitzat per: Francisco Jose Aguilar Celdran                                           --
--                Sergio Blanco Cuaresma                                                   --
---------------------------------------------------------------------------------------------

package body Accions is

   --------------------------
   -- Inicialitzar_Accions --
   --------------------------

   procedure Inicialitzar_Accions (Ac: out Accio; OK: out Boolean) is
   begin
      Crear_Llista(Ac.Accions_Interficie,Ok);
   end Inicialitzar_Accions;

   ------------------
   -- Afegir_Accio --
   ------------------

   procedure Afegir_Accio (Ac: in out Accio; Dades: in Info_Accio; OK: out Boolean) is
   begin
      Afegir_Element(Ac.Accions_Interficie,Dades,Ok);
   end Afegir_Accio;

   --------------------
   -- Obtenir_Accio --
   --------------------

   procedure Obtenir_Accio (Ac: in out Accio; Dades: out Info_Accio; OK: out Boolean) is
   begin
      Dades := Primer_Element(Ac.Accions_Interficie);
      Esborrar_Element(Ac.Accions_Interficie,Dades,OK);
   end Obtenir_Accio;

   ----------------------
   -- Comparar_Accions --
   ----------------------

   function Comparar_Accions (A1: in Info_Accio; A2: in Info_Accio) return boolean is
   begin
      if (A1.Id = A2.Id and A1.Tipus = A2.Tipus and A1.Vehicle = A2.Vehicle and
          A1.Grua = A2.Grua and A1.Escombraries = A2.Escombraries and
          A1.Posicio_Vehicle = A2.Posicio_Vehicle and A1.Num_Cruilla = A2.Num_Cruilla
          and A1.Semafor_Verd = A2.Semafor_Verd) then
         return True;
      else
         return False;
      end if;
   end Comparar_Accions;

   -------------------
   -- Copiar_Accio --
   -------------------

   procedure Copiar_Accio (A1: in Info_Accio; A2: out Info_Accio) is
   begin
      A2 := A1;
   end Copiar_Accio;

   --------------------
   -- Queden_Accions --
   --------------------

   function Queden_Accions (Ac: in Accio) return Boolean is
   begin
      return not Llista_Buida(Ac.Accions_Interficie);
   end Queden_Accions;

end Accions;





