
------------------------------------------------------------------------------------------
-- Practica de Enginyeria del Software II / Curs 2003 - 2004                            --
-- Simulador i Controlador de Transit en Temps Real                                     --
--                                                                                      --
-- Accions.ads: Fitxer descriptor del modul Accions, amb les especificacions dels       --
--              procediments, funcions i tipus de dades que s'empren en la              --
--              implementacio d'aquest package.                                         --
-- Realitzat per: Francisco Jose Aguilar Celdran                                        --
--                Sergio Blanco Cuaresma                                                --
------------------------------------------------------------------------------------------


with Llista_Dinamica;
with Tipus_Comuns; use Tipus_Comuns;

package Accions is

   type Accio is limited private;

   type Tipus_Accio is (Moure_Vehicle,Canviar_Semafors,Treure_Del_Garatge,Guardar_En_Garatge,
                        Recollir_Avariat, Avariat_A_Taller, Vehicle_Avariat, Actualitzar_Flow);

   type Info_Accio is record
      Tipus : Tipus_Accio;
      Id : Positive;
      Vehicle : Tipus_Vehicle;
      Grua : Boolean;
      Escombraries : Boolean;
      Posicio_Vehicle : Coordenada;
      Num_Cruilla : Coordenada;
      Semafor_Verd : Direccio;
      Valor: Duration;
   end record;

   procedure Inicialitzar_Accions (Ac: out Accio; OK: Out Boolean);
   procedure Afegir_Accio (Ac: in out Accio; Dades: in Info_Accio; OK: out Boolean);
   procedure Obtenir_Accio (Ac: in out Accio; Dades: out Info_Accio; OK: out Boolean);
   function Queden_Accions (Ac: in Accio) return Boolean;
   procedure Copiar_Accio (A1: in Info_Accio; A2: out Info_Accio);
   function Comparar_Accions (A1: in Info_Accio; A2: in Info_Accio) return boolean;

   package Llista_Accions is new Llista_Dinamica(Elem => Info_Accio, Copiar_Element => Copiar_Accio,
                                                 Comparar_Element => Comparar_Accions);

   use Llista_Accions;


private

   type Accio is record
      Accions_Interficie : Llista;
   end record;

end Accions;





