
---------------------------------------------------------------------------------------------
-- Practica de Enginyeria del Software II / Curs 2003 - 2004                               --
-- Simulador i Controlador de Transit en Temps Real                                        --
--                                                                                         --
-- Avaries.adb: Implementacio d'una instancia de Llista_Dinamica per tractar les diferents --
--              operacions de manegament de les avaries de vehicles, de forma abstracta    --
--              per encapsular la implementacio del tipus de dades emprat per gestionar    --
--              les avaries dels vehicles.                                                 --
-- Realitzat per: Francisco Jose Aguilar Celdran                                           --
--                Sergio Blanco Cuaresma                                                   --
---------------------------------------------------------------------------------------------


package body Avaries is

   --------------------------
   -- Inicialitzar_Avaries --
   --------------------------

   procedure Inicialitzar_Avaries (Av: out Avaria; OK: out Boolean) is
   begin
      Crear_Llista(Av.Avaries_Vehicles,OK);
   end Inicialitzar_Avaries;

   -------------------
   -- Afegir_Avaria --
   -------------------

   procedure Afegir_Avaria (Av: in out Avaria; Dades: in Info_Avaria; OK: out Boolean) is
   begin
      Afegir_Element(Av.Avaries_Vehicles,Dades,OK);
   end Afegir_Avaria;

   --------------------
   -- Obtenir_Avaria --
   --------------------

   procedure Obtenir_Avaria (Av: in out Avaria; Dades: out Info_Avaria; OK: out Boolean) is
   begin
      Dades := Primer_Element(Av.Avaries_Vehicles);
      Esborrar_Element(Av.Avaries_Vehicles,Dades,OK);
   end Obtenir_Avaria;

   ----------------------
   -- Comparar_Avaries --
   ----------------------

   function Comparar_Avaries (A1: in Info_Avaria; A2: in Info_Avaria) return boolean is
   begin
      if (A1.Id_Vehicle = A2.Id_Vehicle and A1.Tipus = A2.Tipus) then
         return True;
      else
         return False;
      end if;
   end Comparar_Avaries;

   -------------------
   -- Copiar_Avaria --
   -------------------

   procedure Copiar_Avaria (A1: in Info_Avaria; A2: out Info_Avaria) is
   begin
      A2 := A1;
   end Copiar_Avaria;

end Avaries;





