
------------------------------------------------------------------------------------------
-- Practica de Enginyeria del Software II / Curs 2003 - 2004                            --
-- Simulador i Controlador de Transit en Temps Real                                     --
--                                                                                      --
-- Avaries.ads: Fitxer descriptor del modul Avaries, amb les especificacions dels       --
--              procediments, funcions i tipus de dades que s'empren en la              --
--              implementacio d'aquest package.                                         --
-- Realitzat per: Francisco Jose Aguilar Celdran                                        --
--                Sergio Blanco Cuaresma                                                --
------------------------------------------------------------------------------------------

with Tipus_Comuns; use Tipus_Comuns;
with Llista_Dinamica;

package Avaries is

   type Avaria is limited private;

   type Info_Avaria is record
      Id_Vehicle : Positive;
      Tipus : Tipus_Vehicle;
      Pos_X : Positive;
      Pos_Y : Positive;
      Num_Carrer : Positive;
      Orientacio : Direccio;
   end record;

   procedure Inicialitzar_Avaries (Av: out Avaria; OK: Out Boolean);
   procedure Afegir_Avaria (Av: in out Avaria; Dades: in Info_Avaria; OK: out Boolean);
   procedure Obtenir_Avaria (Av: in out Avaria; Dades: out Info_Avaria; OK: out Boolean);
   procedure Copiar_Avaria (A1: in Info_Avaria; A2: out Info_Avaria);
   function Comparar_Avaries (A1: in Info_Avaria; A2: in Info_Avaria) return boolean;

   package Llista_Avaries is new Llista_Dinamica(Elem => Info_Avaria, Copiar_Element => Copiar_Avaria,
                                                 Comparar_Element => Comparar_Avaries);
   use Llista_Avaries;

private

   type Avaria is record
      Avaries_Vehicles : Llista;
   end record;

end Avaries;





