
--------------------------------------------------------------------------------------------
-- Practica de Enginyeria del Software II / Curs 2003 - 2004                              --
-- Simulador i Controlador de Transit en Temps Real                                       --
--                                                                                        --
-- Cruilles.adb: Implementacio de una cruilla de la ciutat del simulador, amb un objecte  --
--               protegit que permet accedir en exclusio mutua per consultar i modificar  --
--               el semafor horitontal i el semafor vertical de la cruilla.               --
-- Realitzat per: Francisco Jose Aguilar Celdran                                          --
--                Sergio Blanco Cuaresma                                                  --
--------------------------------------------------------------------------------------------


package body Cruilles is

   ------------------------------
   -- Establir_Colors_Inicials --
   ------------------------------

   procedure Establir_Colors_Inicials (C: in out Cruilla; Color_H, Color_V: in Estat_Semafor) is
   begin
      C.Inicialitzar_Horitzontal(Color_H);
      C.Inicialitzar_Vertical(Color_V);
   end Establir_Colors_Inicials;


   -------------------------------
   -- Color_Semafor_Horitzontal --
   -------------------------------
   function Color_Semafor_Horitzontal (C: in Cruilla) return Estat_Semafor is
   begin
      return C.Color_Semafor_Horitzontal;
   end Color_Semafor_Horitzontal;

   ----------------------------
   -- Color_Semafor_Vertical --
   ----------------------------
   function Color_Semafor_Vertical (C: in Cruilla) return Estat_Semafor is
   begin
      return C.Color_Semafor_Vertical;
   end Color_Semafor_Vertical;

   -------------------------------
   -- Alternar_Semafors_Cruilla --
   -------------------------------
   procedure Alternar_Semafors_Cruilla (C: in out Cruilla) is
   begin
     C.Canviar_Semafors_Cruilla;
   end Alternar_Semafors_Cruilla;

   -----------------------------------
   -- Travessar_Semafor_Horitzontal --
   -----------------------------------
   procedure Travessar_Semafor_Horitzontal (C: in out Cruilla) is
   begin
      C.Travessar_Sem_Horitzontal;
   end Travessar_Semafor_Horitzontal;

   --------------------------------
   -- Travessar_Semafor_Vertical --
   --------------------------------
   procedure Travessar_Semafor_Vertical (C: in out Cruilla) is
   begin
      C.Travessar_Sem_Vertical;
   end Travessar_Semafor_Vertical;

   -----------------------------------
   -- Modificar_Semafor_Horitzontal --
   -----------------------------------
   procedure Modificar_Semafor_Horitzontal (C: in out Cruilla; Color: in Estat_Semafor) is
   begin
      C.Canviar_Estat_Horitzontal(Color);
   end Modificar_Semafor_Horitzontal;

   --------------------------------
   -- Modificar_Semafor_Vertical --
   --------------------------------
   procedure Modificar_Semafor_Vertical (C: in out Cruilla; Color: in Estat_Semafor) is
   begin
      C.Canviar_Estat_Vertical(Color);
   end Modificar_Semafor_Vertical;

   -----------------------------------------
   -- Nombre_Vehicles_Aturats_Horitzontal --
   -----------------------------------------

   function Nombre_Vehicles_Aturats_Horitzontal (C: in Cruilla) return Natural is
   begin
      return C.Cua_Semafor_Horitzontal;
   end Nombre_Vehicles_Aturats_Horitzontal;

   --------------------------------------
   -- Nombre_Vehicles_Aturats_Vertical --
   --------------------------------------

   function Nombre_Vehicles_Aturats_Vertical (C: in Cruilla) return Natural is
   begin
      return C.Cua_Semafor_Vertical;
   end Nombre_Vehicles_Aturats_Vertical;

   -------------
   -- Cruilla --
   -------------

   protected body Cruilla is
      ------------------------------
      -- Inicialitzar_Horitzontal --
      ------------------------------

      procedure Inicialitzar_Horitzontal (Color: in Estat_Semafor) is
      begin
         Semafor_Horitzontal := Color;
      end Inicialitzar_Horitzontal;

      ---------------------------
      -- Inicialitzar_Vertical --
      ---------------------------

      procedure Inicialitzar_Vertical (Color: in Estat_Semafor) is
      begin
         Semafor_Vertical := Color;
      end Inicialitzar_Vertical;

      -------------------------------
      -- Color_Semafor_Horitzontal --
      -------------------------------

      function Color_Semafor_Horitzontal return Estat_Semafor is
      begin
         return Semafor_Horitzontal;
      end Color_Semafor_Horitzontal;

      ----------------------------
      -- Color_Semafor_Vertical --
      ----------------------------

      function Color_Semafor_Vertical return Estat_Semafor is
      begin
         return Semafor_Vertical;
      end Color_Semafor_Vertical;

      -----------------------------------
      -- Travessar_Semafor_Horitzontal --
      -----------------------------------

      entry Travessar_Sem_Horitzontal when Semafor_Horitzontal = Verd is

      begin
         null;
      end Travessar_Sem_Horitzontal;


      --------------------------------
      -- Travessar_Semafor_Vertical --
      --------------------------------
      entry Travessar_Sem_Vertical when Semafor_Vertical = Verd is


      begin
         null;
      end Travessar_Sem_Vertical;


      ------------------------------
      -- Canviar_Semafors_Cruilla --
      ------------------------------

      procedure Canviar_Semafors_Cruilla is
      begin
         if Semafor_Horitzontal = Vermell then
            Semafor_Vertical := Vermell;
            Semafor_Horitzontal := Verd;
         else
            Semafor_Horitzontal := Vermell;
            Semafor_Vertical := Verd;
         end if;
      end Canviar_Semafors_Cruilla;

      -------------------------------
      -- Canviar_Estat_Horitzontal --
      -------------------------------
      procedure Canviar_Estat_Horitzontal (Color: in Estat_Semafor) is
      begin
         Semafor_Horitzontal := Color;
      end Canviar_Estat_Horitzontal;


      ----------------------------
      -- Canviar_Estat_Vertical --
      ----------------------------

      procedure Canviar_Estat_Vertical (Color: in Estat_Semafor) is
      begin
         Semafor_Horitzontal := Color;
      end Canviar_Estat_Vertical;

      -----------------------------
      -- Cua_Semafor_Horitzontal --
      -----------------------------
      function Cua_Semafor_Horitzontal return Natural is
      begin
         return Travessar_Sem_Horitzontal'Count;
      end Cua_Semafor_Horitzontal;

      --------------------------
      -- Cua_Semafor_Vertical --
      --------------------------

      function Cua_Semafor_Vertical return Natural is
      begin      
         return Travessar_Sem_Vertical'Count;
      end Cua_Semafor_Vertical;

   end Cruilla;

end Cruilles;



