
------------------------------------------------------------------------------------------
-- Practica de Enginyeria del Software II / Curs 2003 - 2004                            --
-- Simulador i Controlador de Transit en Temps Real                                     --
--                                                                                      --
-- Cruilles.ads: Fitxer descriptor del modul Cruilles, amb les especificacions dels     --
--              procediments, funcions, tipus de dades i objectes protegits que         --
--              s'empren en la implementacio d'aquest package.                          --
-- Realitzat per: Francisco Jose Aguilar Celdran                                        --
--                Sergio Blanco Cuaresma                                                --
------------------------------------------------------------------------------------------


package Cruilles is

   type Cruilla is limited private;
   type Estat_Semafor is (Verd,Vermell);

   procedure Establir_Colors_Inicials(C: in out Cruilla; Color_H, Color_V: in Estat_Semafor);
   function Color_Semafor_Horitzontal (C: in Cruilla) return Estat_Semafor;
   function Color_Semafor_Vertical (C: in Cruilla) return Estat_Semafor;
   procedure Travessar_Semafor_Horitzontal (C: in out Cruilla);
   procedure Travessar_Semafor_Vertical (C: in out Cruilla);
   procedure Alternar_Semafors_Cruilla (C: in out Cruilla);
   procedure Modificar_Semafor_Horitzontal (C: in out Cruilla; Color: in Estat_Semafor);
   procedure Modificar_Semafor_Vertical (C: in out Cruilla; Color: in Estat_Semafor);
   function Nombre_Vehicles_Aturats_Horitzontal (C: in Cruilla) return Natural;
   function Nombre_Vehicles_Aturats_Vertical (C: in Cruilla) return Natural;

private

   protected type Cruilla is
      procedure Inicialitzar_Horitzontal (Color: in Estat_Semafor);
      procedure Inicialitzar_Vertical (Color: in Estat_Semafor);
      function Color_Semafor_Horitzontal return Estat_Semafor;
      function Color_Semafor_Vertical return Estat_Semafor;

      entry Travessar_Sem_Horitzontal;
      entry Travessar_Sem_Vertical;

      procedure Canviar_Semafors_Cruilla;
      procedure Canviar_Estat_Horitzontal (Color: in Estat_Semafor);
      procedure Canviar_Estat_Vertical (Color: in Estat_Semafor);
      function Cua_Semafor_Horitzontal return Natural;
      function Cua_Semafor_Vertical return Natural;

   private
      Semafor_Horitzontal : Estat_Semafor;
      Semafor_Vertical : Estat_Semafor;

   end Cruilla;

end Cruilles;



