
------------------------------------------------------------------------------------------
-- Practica de Enginyeria del Software II / Curs 2003 - 2004                            --
-- Simulador i Controlador de Transit en Temps Real                                     --
--                                                                                      --
-- Interficievisual.ads: Fitxer descriptor del modul Interficievisual, amb les          --
--                  especificacions dels procediments, funcions i tipus de dades que    --
--                  s'empren en la implementacio d'aquest package.                      --
-- Realitzat per: Francisco Jose Aguilar Celdran                                        --
--                Sergio Blanco Cuaresma                                                --
------------------------------------------------------------------------------------------

with Glib;              use Glib;
with Double_Buffer;     use Double_Buffer;
with Gtk.Window;        use Gtk.Window;
with Gtk.Label;         use Gtk.Label;
with Gtk.GEntry;         use Gtk.GEntry;
with Ada.Real_Time; use Ada.Real_Time;
with Tipus_Comuns; use Tipus_Comuns;
with Llista_Dinamica;

package InterficieVisual is
  --type GUIrecord is private;
  --type GUIrecord_ptr is access all GUIrecord;
   type TVehicle is record
      Id : Positive;
      X, Y: Gint;
      Avariat: Boolean;
   end record;

   type PTVehicle is access TVehicle;

   procedure GUI_Start;
   procedure DrawCity;
   procedure ChangeSemaphore (X, Y: Gint; Stop: Boolean);
   procedure MoveVehicle(V: TVehicle; Tipus: Tipus_Vehicle);
   procedure MoveCamioGrua(V: TVehicle; Tipus: Tipus_Vehicle);
   procedure MoveCamioBrossa(V: TVehicle; Tipus: Tipus_Vehicle);
   procedure CamioGruaToGarage;
   procedure CamioBrossaToGarage;
   procedure CamioGruaTakeCar(V: TVehicle; Tipus: Tipus_Vehicle);
   procedure CamioGruaLeaveCar;
   procedure CamioGruaToStreet;
   procedure CamioBrossaToStreet;
   procedure Flow(Num: String);
   procedure Copiar_Sem (S1: in Boolean; S2: out Boolean);
   function Comparar_Sem (S1: in Boolean; S2: in Boolean) return boolean;  

   package Llista_Sem is new Llista_Dinamica(Elem => Boolean, Copiar_Element => Copiar_Sem,
                                                 Comparar_Element => Comparar_Sem);

   use Llista_Sem;

   procedure Copiar_Vehicle (V1: in TVehicle; V2: out TVehicle);
   function Comparar_Vehicle (V1: in TVehicle; V2: in TVehicle) return boolean;  

   package Llista_Vehicle is new Llista_Dinamica(Elem => TVehicle, Copiar_Element => Copiar_Vehicle,
                                                 Comparar_Element => Comparar_Vehicle);

   use Llista_Vehicle;

end InterficieVisual;





